Bug 3089 - Crash when losing network connection while fetching IMAP data
Summary: Crash when losing network connection while fetching IMAP data
Status: RESOLVED FIXED
Alias: None
Product: Claws Mail
Classification: Unclassified
Component: Folders/IMAP (show other bugs)
Version: 3.9.3
Hardware: PC Linux
: P3 normal
Assignee: users
URL:
Depends on:
Blocks:
 
Reported: 2014-02-13 19:20 UTC by Kasper Peeters
Modified: 2014-04-30 21:39 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Kasper Peeters 2014-02-13 19:20:31 UTC
I have claws set to fetch new mail every minute. If I lose my network connection while it is fetching data, and then network connection then comes back up at a later stage (while claws is still in the uninterruptible state of fetching from the imap server), the program will eventually crash.

Am happy to provide more detailed data like network logs or a backtrace if you let me know what you need.
Comment 1 Kasper Peeters 2014-02-13 21:24:28 UTC
This may be related to bug 2769.
Comment 2 Michael Schwendt 2014-02-28 13:39:14 UTC
That's likely.

Bug 2769 is just the tip of the iceberg though, since it's one way to forcefully go offline and increase the chance of triggering a crash as a side-effect (of some part of the code continueing to use freed memory structures possibly). The alternative (with Network Manager support) is to interrupt the networking connection (e.g. plug a cable or reset the used (W)LAN router). The symptoms of the crash are those of a race-condition and not 100% reproducibly, but they plague various Claws Mail users.

See comments in bug 3084 for some more background.
Comment 3 Christopher Barry 2014-03-20 13:51:43 UTC
This is happening to me as well - several times a day. It did so in past as well, but it feels like since upgrading to 3.9.3 it's only gotten worse. I'm running Debian SID.

In the middle of typing an email, it'll just segfault if the IMAP server is busy or something. I'm certain GoDaddy's IMAP servers suck, but that should never cause the email client to segfault.

One thing I don't really understand, is why do local folders *not* appear immediately when re-starting after a crash, or when starting at any time? Maybe it's me, but it would seem to make sense to load all local data immediately, then try to hit the server(s) for accounts in the background asynchronously, updating the displayed list if and when the data becomes available. Blocking while the application tries to connect to a remote machine seems very, well, 'Windowsy' to me. Is there some reason this does not occur in a non-blocking thread?

Regards,
-C
Comment 4 Paul 2014-03-20 13:59:55 UTC
(In reply to comment #3)

did you also upgrade libetpan during this time period?
Comment 5 Christopher Barry 2014-03-20 14:10:34 UTC
crap - just did it for the third time in an hour. Hadn't even left this bugzilla page yet! I *really* don't want to go back to evo, but I'm beginning to feel like I'll have to...
Comment 6 Christopher Barry 2014-03-20 14:12:15 UTC
(In reply to comment #4)
> (In reply to comment #3)
> 
> did you also upgrade libetpan during this time period?

I upgrade my entire machine at least weekly, and just did it 2 days ago. If libetpan is a dep of claws, then it should have been updated as well.

What version of libetpan should be on the box?
Comment 7 Christopher Barry 2014-03-20 14:19:45 UTC
(In reply to comment #6)
> (In reply to comment #4)
> > (In reply to comment #3)
> > 
> > did you also upgrade libetpan during this time period?
> 
> I upgrade my entire machine at least weekly, and just did it 2 days ago. If
> libetpan is a dep of claws, then it should have been updated as well.
> 
> What version of libetpan should be on the box?

Here's what I have:
Package: libetpan15
Versions:
1.0-5+b1 (/var/lib/apt/lists/debian.lcs.mit.edu_debian_dists_jessie_main_binary-amd64_Packages) (/var/lib/apt/lists/debian.lcs.mit.edu_debian_dists_sid_main_binary-amd64_Packages) (/var/lib/dpkg/status)
 Description Language:
                 File: /var/lib/apt/lists/debian.lcs.mit.edu_debian_dists_wheezy_main_binary-amd64_Packages
                  MD5: df774740059241c7aee9009f941e05d9
 Description Language: en
                 File: /var/lib/apt/lists/debian.lcs.mit.edu_debian_dists_wheezy_main_i18n_Translation-en
                  MD5: df774740059241c7aee9009f941e05d9

1.0-5 (/var/lib/apt/lists/debian.lcs.mit.edu_debian_dists_wheezy_main_binary-amd64_Packages)
 Description Language:
                 File: /var/lib/apt/lists/debian.lcs.mit.edu_debian_dists_wheezy_main_binary-amd64_Packages
                  MD5: df774740059241c7aee9009f941e05d9
 Description Language: en
                 File: /var/lib/apt/lists/debian.lcs.mit.edu_debian_dists_wheezy_main_i18n_Translation-en
                  MD5: df774740059241c7aee9009f941e05d9


Reverse Depends:
  libetpan15:i386,libetpan15
  libetpan-dev,libetpan15 1.0-5+b1
  libetpan-dbg,libetpan15 1.0-5+b1
  claws-mail-vcalendar-plugin,libetpan15 1.0
  claws-mail-tnef-parser,libetpan15 1.0
  claws-mail-spamassassin,libetpan15 1.0
  claws-mail-spam-report,libetpan15 1.0
  claws-mail-smime-plugin,libetpan15 1.0
  claws-mail-python-plugin,libetpan15 1.0
  claws-mail-pgpmime,libetpan15 1.0
  claws-mail-pgpinline,libetpan15 1.0
  claws-mail-perl-filter,libetpan15 1.0
  claws-mail-pdf-viewer,libetpan15 1.0
  claws-mail-newmail-plugin,libetpan15 1.0
  claws-mail-multi-notifier,libetpan15 1.0
  claws-mail-mailmbox-plugin,libetpan15 1.0
  claws-mail-gdata-plugin,libetpan15 1.0
  claws-mail-fetchinfo-plugin,libetpan15 1.0
  claws-mail-feeds-reader,libetpan15 1.0
  claws-mail-fancy-plugin,libetpan15 1.0
  claws-mail-clamd-plugin,libetpan15 1.0
  claws-mail-bsfilter-plugin,libetpan15 1.0
  claws-mail-bogofilter,libetpan15 1.0
  claws-mail-attach-warner,libetpan15 1.0
  claws-mail-attach-remover,libetpan15 1.0
  claws-mail-archiver-plugin,libetpan15 1.0
  claws-mail-address-keeper,libetpan15 1.0
  claws-mail-acpi-notifier,libetpan15 1.0
  claws-mail,libetpan15 1.0
  cairo-dock-mail-plug-in,libetpan15 1.0
  libetpan15:i386,libetpan15
  libetpan-dev,libetpan15 1.0-5
  libetpan-dbg,libetpan15 1.0-5
  claws-mail-trayicon,libetpan15 1.0
  claws-mail-spamassassin,libetpan15 1.0
  claws-mail-smime-plugin,libetpan15 1.0
  claws-mail-pgpmime,libetpan15 1.0
  claws-mail-pgpinline,libetpan15 1.0
  claws-mail-bogofilter,libetpan15 1.0
  claws-mail,libetpan15 1.0
  cairo-dock-mail-plug-in,libetpan15 1.0
Dependencies:
1.0-5+b1 - libc6 (2 2.14) libcurl3-gnutls (2 7.16.2) libdb5.1 (0 (null)) libexpat1 (2 2.0.1) libgcc1 (2 1:4.1.1) libgnutls26 (2 2.12.17-0) liblockfile1 (2 1.0) libsasl2-2 (0 (null)) libstdc++6 (2 4.1.1) libetpan15:i386 (0 (null))
1.0-5 - libc6 (2 2.3.2) libcurl3-gnutls (2 7.16.2-1) libdb5.1 (0 (null)) libexpat1 (2 1.95.8) libgcc1 (2 1:4.1.1) libgnutls26 (2 2.12.6.1-0) liblockfile1 (2 1.0) libsasl2-2 (0 (null)) libstdc++6 (2 4.1.1) libetpan15:i386 (0 (null))
Provides:
1.0-5+b1 -
1.0-5 -
Comment 8 Christopher Barry 2014-03-20 19:00:58 UTC
Not that this really fixes the underlying issues with blocking, segfaults on weird connections, etc., but I just dumped godaddy imap email and moved my domain over to rackspace - so far it's completely night and day. The much more robust network and likely less loaded servers are working great now.

-C
Comment 9 Colin Leroy 2014-04-21 14:34:43 UTC
The fix for bug #3145 may help.  Can you test?
Comment 10 Colin Leroy 2014-04-30 21:06:17 UTC
It's probably fixed.
Comment 11 Kasper Peeters 2014-04-30 21:17:46 UTC
(In reply to comment #10)
> It's probably fixed.

Sorry guys, I simply did not have the time to check if this fixes the problem. Many thanks for this.
Comment 12 Colin Leroy 2014-04-30 21:39:24 UTC
No problem :)